/******************************************************************************
 * CLASSIFICATION: UNLASSIFIED//FOUO>
 *
 * Copyright(C) ProLogic, Incorporated 2008, 1000 Technology Drive, Fairmont, WV 26554
 * Produced pursuant to U.S. Government sponsorship.
 * 
 * Copyright applies to commercial uses only. Not withstanding the above
 * copyright/restriction, the Government possesses DFARS 252.227-7013. 
 * Unlimited Rights if this is technical data and DFARS 252.227-7014. 
 * Unlimited Rights if this is computer software or computer software 
 * documentation.
 * 
 * $Id: $
 *****************************************************************************/
/**
 * @file
 * Defines macros to accomodate compiler and platform differences and limitations.
 * Inspired by boost's config mechanisms.  Like boost, we choose to separate 
 * compiler config from platform config.  This file is intended as a top-level
 * include, that may be broken into subfiles as it grows.  See "boost/select_-
 * compiler_config.hpp" and "~platform_config.hpp" for test details.
 */

///////////////////////////////////////////////////////////////////////////////
// include this file only once
///////////////////////////////////////////////////////////////////////////////
#pragma once



//This macro expands to a noop.  It can be used to remove warnings issued by some
//compilers that complain about unused parameters.  E.g.,
//
//   void foo( int never_used )
//   {
//      NOOP(never_used);
//      ...
//
#ifndef NOOP
#	define NOOP(x) (void)x
#endif



//Test for wstring support
#ifndef __CYGWIN__
#	define HAS_WSTRING
#endif



//Test for secure functions
#if defined(_MSC_VER) && !defined(UNDER_CE)
#	define HAS_STDC_SECURE
#endif


