#include <stdlib.h>
#include <stdio.h>
#include <err.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <termios.h>

static int _modem_send(const char *path)
{
    int fd, r;

    if (-1 == (fd = open(path, O_WRONLY | O_NOCTTY))) {
        perror("open");
        return -1;
    }

    if (-1 == (r = tcflush(fd, TCOFLUSH))) {
        perror("tcflush");
        goto out;
    }

    while (1) {
        char buffer[1024], *p;
        int len;

        if (-1 == (r = (int)read(0, buffer, sizeof(buffer)))) {
            perror("read");
            goto out;
        }

        for (p = buffer, len = r; len > 0; p += r, len -= r) {
            if (-1 == (r = (int)write(fd, p, len))) {
                perror("write");
                goto out;
            }
        }
    }

out:
    close(fd);
    return r;
}

int main(int argc, char *argv[])
{
    if (argc < 2)
    {
        printf("send /dev/ttyACM1\n");
        return 0;
    }

    return _modem_send(argv[1]);
}
